ListUI (Java SE 26 & JDK 26)
Description: declaration: module: java.desktop, package: javax.swing.plaf, class: ListUI
Keywords: javax.swing.plaf.ListUI class

# Class ListUI

java.lang.Object
javax.swing.plaf.ComponentUI
javax.swing.plaf.ListUI

Direct Known Subclasses:
  `BasicListUI, MultiListUI`

public abstract class ListUI extends ComponentUI
The `JList` pluggable look and feel delegate.

- ## Constructor Summary

  Constructors
  Modifier
  Constructor
  Description
  `protected`
  `ListUI()`
  Constructor for subclasses to call.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `abstract Rectangle`
  `getCellBounds(JList<?> list, int index1, int index2)`
  Returns the bounding rectangle, in the given list's coordinate system, for the range of cells specified by the two indices.
  `abstract Point`
  `indexToLocation(JList<?> list, int index)`
  Returns the origin in the given `JList`, of the specified item, in the list's coordinate system.
  `abstract int`
  `locationToIndex(JList<?> list, Point location)`
  Returns the cell index in the specified `JList` closest to the given location in the list's coordinate system.

  ### Methods declared in class ComponentUI

  `contains, createUI, getAccessibleChild, getAccessibleChildrenCount, getBaseline, getBaselineResizeBehavior, getMaximumSize, getMinimumSize, getPreferredSize, installUI, paint, uninstallUI, update`
  Modifier and Type
  Method
  Description
  `boolean`
  `contains(JComponent c, int x, int y)`
  Returns `true` if the specified x,y location is contained within the look and feel's defined shape of the specified component.
  `static ComponentUI`
  `createUI(JComponent c)`
  Returns an instance of the UI delegate for the specified component.
  `Accessible`
  `getAccessibleChild(JComponent c, int i)`
  Returns the `i`th `Accessible` child of the object.
  `int`
  `getAccessibleChildrenCount(JComponent c)`
  Returns the number of accessible children in the object.
  `int`
  `getBaseline(JComponent c, int width, int height)`
  Returns the baseline.
  `Component.BaselineResizeBehavior`
  `getBaselineResizeBehavior(JComponent c)`
  Returns an enum indicating how the baseline of the component changes as the size changes.
  `Dimension`
  `getMaximumSize(JComponent c)`
  Returns the specified component's maximum size appropriate for the look and feel.
  `Dimension`
  `getMinimumSize(JComponent c)`
  Returns the specified component's minimum size appropriate for the look and feel.
  `Dimension`
  `getPreferredSize(JComponent c)`
  Returns the specified component's preferred size appropriate for the look and feel.
  `void`
  `installUI(JComponent c)`
  Configures the specified component appropriately for the look and feel.
  `void`
  `paint(Graphics g, JComponent c)`
  Paints the specified component appropriately for the look and feel.
  `void`
  `uninstallUI(JComponent c)`
  Reverses configuration which was done on the specified component during `installUI`.
  `void`
  `update(Graphics g, JComponent c)`
  Notifies this UI delegate that it is time to paint the specified component.

  ### Methods declared in class Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`
  Modifier and Type
  Method
  Description
  `protected Object`
  `clone()`
  Creates and returns a copy of this object.
  `boolean`
  `equals(Object obj)`
  Indicates whether some other object is "equal to" this one.
  `protected void`
  `finalize()`
  Deprecated, for removal: This API element is subject to removal in a future version.
  Finalization is deprecated and subject to removal in a future release.
  `final Class<?>`
  `getClass()`
  Returns the runtime class of this `Object`.
  `int`
  `hashCode()`
  Returns a hash code value for this object.
  `final void`
  `notify()`
  Wakes up a single thread that is waiting on this object's monitor.
  `final void`
  `notifyAll()`
  Wakes up all threads that are waiting on this object's monitor.
  `String`
  `toString()`
  Returns a string representation of the object.
  `final void`
  `wait()`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted.
  `final void`
  `wait(long timeoutMillis)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.
  `final void`
  `wait(long timeoutMillis, int nanos)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.

- ## Constructor Details

  - ### ListUI

    protected ListUI()
    Constructor for subclasses to call.

- ## Method Details

  - ### locationToIndex

    public abstract int locationToIndex(JList<?> list, Point location)
    Returns the cell index in the specified `JList` closest to the given location in the list's coordinate system. To determine if the cell actually contains the specified location, compare the point against the cell's bounds, as provided by `getCellBounds`. This method returns `-1` if the list's model is empty.
    Parameters:
      `list` - the list
      `location` - the coordinates of the point
    Returns:
      the cell index closest to the given location, or `-1`
    Throws:
      `NullPointerException` - if `location` is null

  - ### indexToLocation

    public abstract Point indexToLocation(JList<?> list, int index)
    Returns the origin in the given `JList`, of the specified item, in the list's coordinate system. Returns `null` if the index isn't valid.
    Parameters:
      `list` - the list
      `index` - the cell index
    Returns:
      the origin of the cell, or `null`

  - ### getCellBounds

    public abstract Rectangle getCellBounds(JList<?> list, int index1, int index2)
    Returns the bounding rectangle, in the given list's coordinate system, for the range of cells specified by the two indices. The indices can be supplied in any order.

    If the smaller index is outside the list's range of cells, this method returns `null`. If the smaller index is valid, but the larger index is outside the list's range, the bounds of just the first index is returned. Otherwise, the bounds of the valid range is returned.

    Parameters:
      `list` - the list
      `index1` - the first index in the range
      `index2` - the second index in the range
    Returns:
      the bounding rectangle for the range of cells, or `null`